library verilog;
use verilog.vl_types.all;
entity decrypter_pipe is
    generic(
        init1           : integer := 0;
        init2           : integer := 1;
        inv_shift_rows  : integer := 2;
        inv_sub_bytes   : integer := 3;
        wait_state      : integer := 4;
        latch_lut_data  : integer := 5;
        add_round_key   : integer := 6;
        round4a         : integer := 7;
        round4b         : integer := 8;
        round4c         : integer := 9;
        round4d         : integer := 10;
        round4e         : integer := 11;
        done1           : integer := 12;
        init3           : integer := 13;
        init4           : integer := 14;
        init5           : integer := 15;
        done2           : integer := 16;
        dummy1          : integer := 17;
        dummy2          : integer := 18;
        dummy3          : integer := 19;
        dummy4          : integer := 20;
        dummy5          : integer := 21
    );
    port(
        data            : in     vl_logic;
        clock           : in     vl_logic;
        reset           : in     vl_logic;
        expanded_key    : in     vl_logic;
        round_num       : in     vl_logic_vector(3 downto 0);
        out_data        : out    vl_logic;
        round_over      : out    vl_logic
    );
end decrypter_pipe;
